Index: sansview/perspectives/fitting/fitting.py
===================================================================
--- sansview/perspectives/fitting/fitting.py	(revision 81f00d78ada09a013a9eb074a1b0579fa0fea611)
+++ sansview/perspectives/fitting/fitting.py	(revision 6bbeacd466719479cfdf24b6e7c1c5f52c93e03d)
@@ -1191,72 +1075,74 @@
         theory.ymin = ymin 
         theory.ymax = ymax 
-        theory.group_id = "Model"
-        theory.id = "Model"
-        
-    def _get_plotting_info(self, data=None):
-        """
-        get plotting info from data if data !=None else use some default
-        """
-        my_info = PlotInfo()
-        if data !=None:
-            if hasattr(data,"info"):
-                x_name, x_units = data.get_xaxis() 
-                y_name, y_units = data.get_yaxis() 
+        theory.group_id = str(id) + "Model2D"
+        theory.id = str(id) + "Mode2D"
+  
                 
-                my_info._xunit = x_units
-                my_info._xaxis = x_name
-                my_info._yunit = y_units
-                my_info._yaxis = y_name
-                
-            my_info.title= data.name
-            if hasattr(data, "info"):
-                my_info.info= data.info
-            if hasattr(data, "group_id"):
-                my_info.group_id= data.group_id
-        return my_info
-                
-    def _complete1D(self, x,y, elapsed,index,model,data=None):
+    def _complete1D(self, x,y, id, elapsed,index,model,data=None):
         """
         Complete plotting 1D data
         """ 
         try:
-            new_plot = Theory1D(x=x, y=y)
-            my_info = self._get_plotting_info( data)
-            new_plot.name = model.name
-            new_plot.id = my_info.id
-            new_plot.group_id = my_info.group_id
-            
-            new_plot.xaxis(my_info._xaxis,  my_info._xunit)
-            new_plot.yaxis(my_info._yaxis, my_info._yunit)
+            new_plot = Data1D(x=x, y=y)
+            new_plot.symbol = GUIFRAME_ID.CURVE_SYMBOL_NUM
             if data != None:
-                if new_plot.id == data.id:
-                    new_plot.id += "Model"
-                new_plot.is_data =False 
+                _xaxis, _xunit = data.get_xaxis() 
+                _yaxis, _yunit = data.get_yaxis() 
+                new_plot.title = data.name
+                #if the theory is already plotted use the same group id 
+                #to replot
+                if id in self.page_finder:
+                    theory_data = self.page_finder[id].get_theory_data()
+                    if theory_data is not None:
+                        print "theory_data", theory_data.group_id
+                        group_id = theory_data.group_id[len(theory_data.group_id)-1]
+                        if group_id not in data.group_id:
+                            data.group_id.append(group_id)
+                        print "data", data.group_id
+                #data is plotted before the theory, then take its group_id
+                #assign to the new theory
+                group_id = data.group_id[len(data.group_id)-1]
+                if group_id not in new_plot.group_id:
+                    new_plot.group_id.append(group_id)
+            else:
+                _xaxis, _xunit = "\\rm{Q}", 'A^{-1}'
+                _yaxis, _yunit = "\\rm{Intensity} ", "cm^{-1}"
+                new_plot.title = "Analytical model 1D "
+                #find a group id to plot theory without data
+                group_id =  str(id) + " Model1D"  
+                if group_id not in new_plot.group_id:
+                    new_plot.group_id.append(group_id)
+                new_plot.is_data = False 
+            new_plot.id =  str(id) + " Model1D"  
+            #find if this theory was already plotted and replace that plot given
+            #the same id
+            if id in self.page_finder:
+                theory_data = self.page_finder[id].get_theory_data()
+                if theory_data is not None:
+                    temp_id = theory_data.id
+                    new_plot.id = temp_id
+            new_plot.name = model.name + " ["+ str(model.__class__.__name__)+ "]"
+            new_plot.xaxis(_xaxis, _xunit)
+            new_plot.yaxis(_yaxis, _yunit)
+            self.page_finder[id].set_theory_data(new_plot)
            
-            title = new_plot.name
-            # x, y are only in range of index 
-            self.theory_data = new_plot
-            #new_plot.perspective = self.get_perspective()
-            # Pass the reset flag to let the plotting event handler
-            # know that we are replacing the whole plot
-            if title is None:
-                title = "Analytical model 1D "
             if data is None:
                 wx.PostEvent(self.parent, NewPlotEvent(plot=new_plot,
-                             title=str(title), reset=True))
+                             title=str(new_plot.title)))
             else:
                 wx.PostEvent(self.parent, NewPlotEvent(plot=new_plot,
-                                                       title= str(title)))
-            # Chisqr in fitpage
-            current_pg = self.fit_panel.get_current_page()
+                                            title= str(new_plot.title)))
+            current_pg = self.fit_panel.get_page_by_id(id)
             wx.PostEvent(current_pg,
-                         Chi2UpdateEvent(output=self._cal_chisqr(data=data,
-                                                                 index=index)))
+                Chi2UpdateEvent(output=self._cal_chisqr(data=data,
+                                                        id=id,
+                                                        index=index)))
             msg = "Plot 1D  complete !"
             wx.PostEvent( self.parent, StatusEvent(status=msg, type="stop" ))
         except:
-            msg = " Error occurred when drawing %s Model 1D: " % new_plot.name
-            msg += " %s"  % sys.exc_value
-            wx.PostEvent(self.parent, StatusEvent(status=msg, type="stop"))
+            raise
+            #msg = " Error occurred when drawing %s Model 1D: " % new_plot.name
+            #msg += " %s"  % sys.exc_value
+            #wx.PostEvent(self.parent, StatusEvent(status=msg, type="stop"))
    
     def _update2D(self, output,time=None):
@@ -1269,5 +1155,5 @@
         #self.calc_thread.ready(0.01)
     
-    def _complete2D(self, image, data, model, elapsed, index, qmin,
+    def _complete2D(self, image, data, model, id,  elapsed, index, qmin,
                      qmax, qstep=DEFAULT_NPTS):
         """
@@ -1283,10 +1169,12 @@
             self._fill_default_model2D(theory=theory, 
                                        qmax=qmax, 
+                                       id=id,
                                        qstep=qstep,
                                         qmin= qmin)
-        
+           
         else:
-            theory.id = data.id + "Model"
-            theory.group_id = data.name + "Model"
+            theory.id = str(id) + "Model2D"
+            theory.group_id = str(id) + "Model2D"
+         
             theory.x_bins = data.x_bins
             theory.y_bins = data.y_bins
@@ -1305,23 +1193,18 @@
             theory.xmin = data.xmin
             theory.xmax = data.xmax
-        self.theory_data = theory
+        theory.title = "Analytical model 2D "
+        self.page_finder[id].set_theory_data(theory)
+        
         ## plot
         wx.PostEvent(self.parent, NewPlotEvent(plot=theory,
-                         title="Analytical model 2D ", reset=True))
+                         title=theory.title))
         # Chisqr in fitpage
-        current_pg = self.fit_panel.get_current_page()
+        current_pg = self.fit_panel.get_page_by_id(id)
         wx.PostEvent(current_pg,
-            Chi2UpdateEvent(output=self._cal_chisqr(data=data, index=index)))
+            Chi2UpdateEvent(output=self._cal_chisqr(data=data, id=id, index=index)))
         msg = "Plot 2D complete !"
         wx.PostEvent(self.parent, StatusEvent(status=msg, type="stop"))
-     
-    def _on_data_error(self, event):
-        """
-        receives and event from plotting plu-gins to store the data name and 
-        their errors of y coordinates for 1Data hide and show error
-        """
-        self.err_dy = event.err_dy
-         
-    def _draw_model2D(self, model, data=None, smearer=None,
+    
+    def _draw_model2D(self, model, id, data=None, smearer=None,
                       description=None, enable2D=False,
                       qmin=DEFAULT_QMIN, qmax=DEFAULT_QMAX,
@@ -1346,4 +1229,7 @@
                                num=qstep,
                                endpoint=True)
+        if model is None:
+            msg = "Panel with ID: %s does not contained model" % str(id)
+            raise ValueError, msg
         ## use data info instead
         if data is not None:
@@ -1366,4 +1252,5 @@
                                     model=model, 
                                     data=data,
+                                    id=id,
                                     smearer=smearer,
                                     qmin=qmin,
@@ -1375,9 +1262,10 @@
 
         except:
-            msg = " Error occurred when drawing %s Model 2D: " % model.name
-            msg += " %s" % sys.exc_value
-            wx.PostEvent(self.parent, StatusEvent(status=msg))
-
-    def _draw_model1D(self, model, data=None, smearer=None,
+            raise
+            #msg = " Error occurred when drawing %s Model 2D: " % model.name
+            #msg += " %s" % sys.exc_value
+            #wx.PostEvent(self.parent, StatusEvent(status=msg))
+
+    def _draw_model1D(self, model, id, data=None, smearer=None,
                 qmin=DEFAULT_QMIN, qmax=DEFAULT_QMAX, 
                 qstep=DEFAULT_NPTS, enable1D=True):
@@ -1412,5 +1300,6 @@
             self.calc_1D = Calc1D(x=x,
                                   data=data,
-                                  model=model, 
+                                  model=model,
+                                  id=id, 
                                   qmin=qmin,
                                   qmax=qmax,
@@ -1425,5 +1314,5 @@
             wx.PostEvent(self.parent, StatusEvent(status=msg))
 
-    def _cal_chisqr(self, data=None, index=None): 
+    def _cal_chisqr(self, id, data=None, index=None): 
         """
         Get handy Chisqr using the output from draw1D and 2D, 
@@ -1443,5 +1332,6 @@
             index = index & (data.err_data != 0)  
             fn = data.data[index] 
-            gn = self.theory_data.data[index]
+            theory_data = self.page_finder[id].get_theory_data()
+            gn = theory_data.data[index]
             en = data.err_data[index]
         else:
@@ -1457,5 +1347,6 @@
                 dy[dy==0] = 1  
             fn = data.y[index] 
-            gn = self.theory_data.y
+            theory_data = self.page_finder[id].get_theory_data()
+            gn = theory_data.y
             en = dy[index]
         # residual
Index: sansview/perspectives/fitting/model_thread.py
===================================================================
--- sansview/perspectives/fitting/model_thread.py	(revision 5062bbf9abf800e4b5ffab0375da1c4a03967672)
+++ sansview/perspectives/fitting/model_thread.py	(revision 6bbeacd466719479cfdf24b6e7c1c5f52c93e03d)
@@ -15,4 +15,5 @@
     """
     def __init__(self, x, y, data,model,smearer,qmin, qmax,qstep,
+                 id ,
                  completefn = None,
                  updatefn   = None,
@@ -31,4 +32,5 @@
         self.y = y
         self.data= data
+        self.page_id = id
         # the model on to calculate
         self.model = model
@@ -115,12 +117,13 @@
 
         elapsed = time.time()-self.starttime
-        self.complete( image = output,
-                       data = self.data , 
-                       model = self.model,
-                       elapsed = elapsed,
-                       index = index_model,
-                       qmin = self.qmin,
-                       qmax = self.qmax,
-                       qstep = self.qstep )
+        self.complete(image=output,
+                       data=self.data, 
+                       id=self.page_id,
+                       model=self.model,
+                       elapsed=elapsed,
+                       index=index_model,
+                       qmin=self.qmin,
+                       qmax=self.qmax,
+                       qstep=self.qstep)
         
 
@@ -130,4 +133,5 @@
     """
     def __init__(self, x, model,
+                 id,
                  data=None,
                  qmin=None,
@@ -150,4 +154,5 @@
         self.qmax= qmax
         self.model = model
+        self.page_id = id
         self.smearer= smearer
         self.starttime = 0
@@ -172,4 +177,5 @@
        
         self.complete(x=self.x[index], y=output[index], 
+                      id=self.page_id,
                       elapsed=elapsed,index=index, model=self.model,
                                         data=self.data)
Index: sansview/perspectives/fitting/models.py
===================================================================
--- sansview/perspectives/fitting/models.py	(revision 6886000a4cc45f87810bae7cd4667d8de793ed71)
+++ sansview/perspectives/fitting/models.py	(revision 6bbeacd466719479cfdf24b6e7c1c5f52c93e03d)
@@ -163,5 +163,9 @@
     ## Event owner (guiframe)
     event_owner = None
-    
+    def __init__(self):
+        """
+        """
+        self._getModelList()
+        
     def _getModelList(self):
         """
@@ -552,4 +556,9 @@
         
         """
+        self.model_combobox.set_list("Shapes", self.shape_list)
+        self.model_combobox.set_list("Shape-Independent", self.shape_indep_list)
+        self.model_combobox.set_list("Structure Factors", self.struct_list)
+        self.model_combobox.set_list("Customized Models", self.plugins)
+        self.model_combobox.set_list("P(Q)*S(Q)", self.multiplication_factor)
         self.model_combobox.set_list("multiplication", self.multiplication_factor)
         self.model_combobox.set_list("Multi-Functions", self.multi_func_list)
Index: sansview/perspectives/fitting/simfitpage.py
===================================================================
--- sansview/perspectives/fitting/simfitpage.py	(revision 4ce74917db4f7013acfaaff394cf25d8213f8eee)
+++ sansview/perspectives/fitting/simfitpage.py	(revision 6bbeacd466719479cfdf24b6e7c1c5f52c93e03d)
@@ -50,10 +50,10 @@
         ##Font size
         self.SetWindowVariant(variant = FONT_VARIANT)
-        
+        self.id = None
         self.parent = parent
         ## store page_finder
         self.page_finder = page_finder
         ## list contaning info to set constraint 
-        ## look like self.constraint_dict[page]= page 
+        ## look like self.constraint_dict[page_id]= page 
         self.constraint_dict={}
         ## item list  self.constraints_list=[combobox1, combobox2,=,textcrtl, button ]
@@ -135,6 +135,6 @@
             self._set_constraint()
         ## get the fit range of very fit problem        
-        for page, value in self.page_finder.iteritems():
-            qmin, qmax= page.get_range()
+        for id, value in self.page_finder.iteritems():
+            qmin, qmax= self.page_finder[id].get_range()
             value.set_range(qmin, qmax)
         ## model was actually selected from this page to be fit
@@ -162,6 +162,6 @@
         check all models names
         """
-        self.model_toFit=[] 
-        if self.cb1.GetValue()==True:
+        self.model_toFit = [] 
+        if self.cb1.GetValue()== True:
             for item in self.model_list:
                 item[0].SetValue(True)
@@ -270,6 +270,6 @@
         for item in self.model_toFit:
             model = item[3]
-            page= item[2]
-            self.constraint_dict[page] = model
+            page_id= item[2]
+            self.constraint_dict[page_id] = model
                    
     def _display_constraint(self, event):
@@ -333,5 +333,5 @@
         btRemove.SetToolTipString("Remove constraint.")
        
-        for page,model in self.constraint_dict.iteritems():
+        for id,model in self.constraint_dict.iteritems():
             ## check if all parameters have been selected for constraint
             ## then do not allow add constraint on parameters
@@ -364,6 +364,6 @@
         hide buttons related constraint 
         """  
-        for page in  self.page_finder.iterkeys():
-            self.page_finder[page].clear_model_param()
+        for id in  self.page_finder.iterkeys():
+            self.page_finder[id].clear_model_param()
                
         self.nb_constraint =0     
@@ -539,5 +539,5 @@
                 msg+= " to set constraint! "
                 wx.PostEvent(self.parent.Parent, StatusEvent(status= msg ))
-            for page , value in self.constraint_dict.iteritems():
+            for id, value in self.constraint_dict.iteritems():
                 if model == value:
                     if constraint == "":
@@ -546,5 +546,5 @@
                         wx.PostEvent(self.parent.Parent, StatusEvent(status= msg ))
                         constraint = None
-                    self.page_finder[page].set_model_param(param,constraint)
+                    self.page_finder[id].set_model_param(param,constraint)
                     break
     
@@ -575,29 +575,44 @@
         sizer.Add(data_used,(iy, ix),(1,1),
                             wx.EXPAND|wx.ADJUST_MINSIZE, 0) 
-        
-        for page, value in self.page_finder.iteritems():
+        ix += 1 
+        tab_used = wx.StaticText(self, -1, '  Fit Tab')
+        tab_used.SetBackgroundColour('grey')
+        sizer.Add(tab_used,(iy, ix),(1,1),
+                            wx.EXPAND|wx.ADJUST_MINSIZE, 0) 
+        for id, value in self.page_finder.iteritems():
             try:
                 ix = 0
                 iy += 1 
                 model = value.get_model()
-                cb = wx.CheckBox(self, -1, str(model.name))
+                name = '_'
+                if model is not None:
+                    name = str(model.name)
+                cb = wx.CheckBox(self, -1, name)
                 cb.SetValue(False)
+                cb.Enable(model is not None)
                 sizer.Add( cb,( iy,ix),(1,1),  wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
                 wx.EVT_CHECKBOX(self, cb.GetId(), self.check_model_name)
-                
                 ix += 2 
                 type = model.__class__.__name__
                 model_type = wx.StaticText(self, -1, str(type))
                 sizer.Add(model_type,( iy,ix),(1,1),  wx.EXPAND|wx.ADJUST_MINSIZE, 0)
+                data = value.get_fit_data()
+                name = '-'
+                if data is not None:
+                    name = str(data.name)
+                data_used = wx.StaticText(self, -1, name)
+                ix += 1 
+                sizer.Add(data_used,( iy,ix),(1,1),  wx.EXPAND|wx.ADJUST_MINSIZE, 0)
+                    
+                ix += 1 
+                caption = value.get_fit_tab_caption()
+                tab_caption_used= wx.StaticText(self, -1, str(caption))
+                sizer.Add(tab_caption_used,( iy,ix),(1,1),  wx.EXPAND|wx.ADJUST_MINSIZE, 0)
                 
-                ix += 1 
-                data = value.get_fit_data()
-                data_used= wx.StaticText(self, -1, str(data.name))
-                sizer.Add(data_used,( iy,ix),(1,1),  wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-                
-                self.model_list.append([cb,value,page,model])
+                self.model_list.append([cb,value,id,model])
                 
             except:
-                pass
+                raise
+                #pass
         iy += 1
         sizer.Add((20,20),( iy,ix),(1,1),  wx.LEFT|wx.EXPAND|wx.ADJUST_MINSIZE, 15)
